<template>

    <div class="card">
        <div class="alert alert-success alert-dismissible fade show" role="alert" v-if="message">
            <strong>{{message}}</strong>
        </div>
        <div class="card-header">
            <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#exampleModal">
                Tambah Data
            </button>

            <!-- Modal -->
            <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="exampleModalLabel">Tambah Data Payment</h5>
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body">

                            <label for="name" class="form-label">Payment Name</label>
                            <input id="name" type="text"  class="form-control" v-model="name" required>
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                            <button type="button" class="btn btn-primary" @click="add">Save changes</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="card-body">
            <table class="table table-bordered">
                <thead>
                <th>Id</th>
                <th>Name</th>
                <th>Created At</th>
                <th>Delete</th>
                </thead>
                <tbody>
                <tr v-for="(payment, index) in payments.data " :key="index">
                    <td>{{payment.id}}</td>
                    <td>{{ payment.name }}</td>
                    <td>{{ payment.created_at }}</td>
                    <td><input type="checkbox" v-model="list_id" :value="payment.id"></td>
                </tr>
                </tbody>
            </table>
            <pagination :data="payments" @pagination-change-page="getResult"></pagination>
        </div>
        <div class="card-footer text-right">
            <button class="btn btn-danger" @click="deletePayment">Delete</button>
        </div>

    </div>
</template>

<script>
    import $ from 'jquery'
    export default {
        data() {
            return {
                payments: {},
                list_id:[],
                message:"",
                name:"",
                errors:{}
            }
        },
        created() {
            this.getResult(1);
            Echo.channel('delete-payment')
                .listen('DeletePayment', (e) => {
                    this.message = e.message;
                    console.log(e);
                    this.list_id.splice(this.list_id.indexOf(e.idPayment));
                    this.getResult()
                });
            console.log("Hallo");
        },
        methods:{
            getResult(page){
                let uri = '/api/payments?page='+page;
                axios.get(uri).then(response =>{
                    return response.data;
                }).then(data => {
                    this.payments = data;
                })

            },
            add(){

                let uri = '/api/payments';
                axios.post(uri,{
                    name: this.name
                }).then(response => {
                    if(response.status === 201){
                        $('#exampleModal').modal('hide');
                        this.message = "Success create data";
                        this.getResult();
                    }else{
                        this.message = response.statusText;
                    }
                }).catch(error => {
                    this.errors = error.response.data.errors;
                })


            },
            deletePayment(){
                let uri = '/api/payments';
                axios.delete(uri, {
                    data:{
                        list_id: this.list_id
                    }
                });
            }
        }
    }
</script>
